#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _credits_dialog_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"<widget class=\"GtkDialog\" id=\"CreditsDialog\">"
"<property name=\"title\" translatable=\"yes\" context=\"yes\" comments=\"Translators: do not translate the part before |\">Dialog title|Credits</property>"
"<property name=\"window_position\">GTK_WIN_POS_CENTER_ON_PARENT</property>"
"<property name=\"default_width\">360</property>"
"<property name=\"default_height\">260</property>"
"<property name=\"destroy_with_parent\">True</property>"
"<property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"<property name=\"has_separator\">False</property>"
"<child internal-child=\"vbox\">"
"<widget class=\"GtkVBox\" id=\"dialog-vbox1\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkNotebook\" id=\"notebook\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkScrolledWindow\" id=\"scrolledwindow4\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"<property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"<property name=\"shadow_type\">GTK_SHADOW_IN</property>"
"<child>"
"<widget class=\"GtkTextView\" id=\"thanks\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_margin\">3</property>"
"<property name=\"right_margin\">3</property>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label8\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\" comments=\"Tab label in Credits dialog\">Thanks</property>"
"</widget>"
"<packing>"
"<property name=\"tab_fill\">False</property>"
"<property name=\"type\">tab</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkScrolledWindow\" id=\"scrolledwindow1\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"<property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"<property name=\"shadow_type\">GTK_SHADOW_IN</property>"
"<child>"
"<widget class=\"GtkTextView\" id=\"written_by:MooHtml\">"
"<property name=\"visible\">True</property>"
"<property name=\"editable\">False</property>"
"<property name=\"left_margin\">3</property>"
"<property name=\"right_margin\">3</property>"
"<property name=\"cursor_visible\">False</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label6\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\" comments=\"Tab label in Credits dialog\">Written by</property>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"<property name=\"tab_fill\">False</property>"
"<property name=\"type\">tab</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkScrolledWindow\" id=\"page_translator_credits\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"<property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"<property name=\"shadow_type\">GTK_SHADOW_IN</property>"
"<child>"
"<widget class=\"GtkTextView\" id=\"translated_by:MooHtml\">"
"<property name=\"visible\">True</property>"
"<property name=\"editable\">False</property>"
"<property name=\"left_margin\">3</property>"
"<property name=\"right_margin\">3</property>"
"<property name=\"cursor_visible\">False</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label1\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\" comments=\"Tab label in Credits dialog\">Translated by</property>"
"</widget>"
"<packing>"
"<property name=\"position\">2</property>"
"<property name=\"tab_fill\">False</property>"
"<property name=\"type\">tab</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child internal-child=\"action_area\">"
"<widget class=\"GtkHButtonBox\" id=\"dialog-action_area1\">"
"<property name=\"visible\">True</property>"
"<property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"<child>"
"<widget class=\"GtkButton\" id=\"close\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">True</property>"
"<property name=\"has_focus\">True</property>"
"<property name=\"can_default\">True</property>"
"<property name=\"has_default\">True</property>"
"<property name=\"label\">gtk-close</property>"
"<property name=\"use_stock\">True</property>"
"<property name=\"response_id\">-6</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"pack_type\">GTK_PACK_END</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct CreditsDialogXml CreditsDialogXml;

struct CreditsDialogXml {
    MooGladeXML *xml;

    GtkDialog *CreditsDialog;
    GtkNotebook *notebook;
    GtkTextView *thanks;
    MooHtml *written_by;
    GtkScrolledWindow *page_translator_credits;
    MooHtml *translated_by;
    GtkButton *close;

};

static void
_credits_dialog_xml_free (CreditsDialogXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static CreditsDialogXml *
credits_dialog_xml_get (gpointer widget)
{
    return (CreditsDialogXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_credits_dialog_xml_finish_build (CreditsDialogXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->CreditsDialog = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "CreditsDialog");
    g_return_val_if_fail (xml->CreditsDialog != NULL, FALSE);
    xml->notebook = (GtkNotebook*) moo_glade_xml_get_widget (xml->xml, "notebook");
    g_return_val_if_fail (xml->notebook != NULL, FALSE);
    xml->thanks = (GtkTextView*) moo_glade_xml_get_widget (xml->xml, "thanks");
    g_return_val_if_fail (xml->thanks != NULL, FALSE);
    xml->written_by = (MooHtml*) moo_glade_xml_get_widget (xml->xml, "written_by:MooHtml");
    g_return_val_if_fail (xml->written_by != NULL, FALSE);
    xml->page_translator_credits = (GtkScrolledWindow*) moo_glade_xml_get_widget (xml->xml, "page_translator_credits");
    g_return_val_if_fail (xml->page_translator_credits != NULL, FALSE);
    xml->translated_by = (MooHtml*) moo_glade_xml_get_widget (xml->xml, "translated_by:MooHtml");
    g_return_val_if_fail (xml->translated_by != NULL, FALSE);
    xml->close = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "close");
    g_return_val_if_fail (xml->close != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->CreditsDialog), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _credits_dialog_xml_free);
    return TRUE;
}

static gboolean
credits_dialog_xml_build (CreditsDialogXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _credits_dialog_xml_glade_xml, -1, "CreditsDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _credits_dialog_xml_finish_build (xml);
}

static gboolean
credits_dialog_xml_fill (CreditsDialogXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _credits_dialog_xml_glade_xml, -1, "CreditsDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _credits_dialog_xml_finish_build (xml);
}

static CreditsDialogXml *
credits_dialog_xml_new_empty (void)
{
    CreditsDialogXml *xml = g_new0 (CreditsDialogXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static CreditsDialogXml *
credits_dialog_xml_new (void)
{
    CreditsDialogXml *xml = credits_dialog_xml_new_empty ();
    if (!credits_dialog_xml_build (xml))
    {
        _credits_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static CreditsDialogXml *
credits_dialog_xml_new_with_root (GtkWidget *root)
{
    CreditsDialogXml *xml = credits_dialog_xml_new_empty ();
    if (!credits_dialog_xml_fill (xml, root))
    {
        _credits_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
