#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _prefs_file_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"<!-- interface-requires gtk+ 2.8 -->"
"<!-- interface-naming-policy toplevel-contextual -->"
"<widget class=\"GtkWindow\" id=\"window4\">"
"<child>"
"<widget class=\"GtkVBox\" id=\"PrefsFile\">"
"<property name=\"visible\">True</property>"
"<property name=\"border_width\">12</property>"
"<property name=\"spacing\">18</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox1\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label1\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">&lt;b&gt;Loading&lt;/b&gt;</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment3\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">12</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox2\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox1\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label12\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">Encodings to _autodetect:</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"mnemonic_widget\">entry_encodings</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"entry_encodings\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Comma-separated list of encodings to try when opening a file. 'LOCALE' means current locale encoding.</property>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox3\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label4\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">&lt;b&gt;Saving&lt;/b&gt;</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment4\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">12</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox4\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox2\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label5\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">Encoding for _new files:</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"mnemonic_widget\">encoding_save</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkComboBoxEntry\" id=\"encoding_save\">"
"<property name=\"visible\">True</property>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"check_strip\">"
"<property name=\"label\" translatable=\"yes\">Remove trailing _spaces</property>"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"check_add_newline\">"
"<property name=\"label\" translatable=\"yes\">Ensure trailing new_line</property>"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"check_make_backups\">"
"<property name=\"label\" translatable=\"yes\">Make _backups</property>"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">3</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox5\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label6\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">&lt;b&gt;Sessions&lt;/b&gt;</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment5\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">12</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox6\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"check_save_session\">"
"<property name=\"label\" translatable=\"yes\">Enable _session support</property>"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox7\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label2\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">&lt;b&gt;Dialogs&lt;/b&gt;</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment1\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">12</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox8\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"check_open_dialog_follows_doc\">"
"<property name=\"label\" translatable=\"yes\">Open and Save As dialogs show current document _folder</property>"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">3</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct PrefsFileXml PrefsFileXml;

struct PrefsFileXml {
    MooGladeXML *xml;

    GtkVBox *PrefsFile;
    GtkEntry *entry_encodings;
    GtkComboBoxEntry *encoding_save;
    GtkCheckButton *check_strip;
    GtkCheckButton *check_add_newline;
    GtkCheckButton *check_make_backups;
    GtkCheckButton *check_save_session;
    GtkCheckButton *check_open_dialog_follows_doc;

};

static void
_prefs_file_xml_free (PrefsFileXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrefsFileXml *
prefs_file_xml_get (gpointer widget)
{
    return (PrefsFileXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_prefs_file_xml_finish_build (PrefsFileXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrefsFile = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "PrefsFile");
    g_return_val_if_fail (xml->PrefsFile != NULL, FALSE);
    xml->entry_encodings = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "entry_encodings");
    g_return_val_if_fail (xml->entry_encodings != NULL, FALSE);
    xml->encoding_save = (GtkComboBoxEntry*) moo_glade_xml_get_widget (xml->xml, "encoding_save");
    g_return_val_if_fail (xml->encoding_save != NULL, FALSE);
    xml->check_strip = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_strip");
    g_return_val_if_fail (xml->check_strip != NULL, FALSE);
    xml->check_add_newline = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_add_newline");
    g_return_val_if_fail (xml->check_add_newline != NULL, FALSE);
    xml->check_make_backups = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_make_backups");
    g_return_val_if_fail (xml->check_make_backups != NULL, FALSE);
    xml->check_save_session = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_save_session");
    g_return_val_if_fail (xml->check_save_session != NULL, FALSE);
    xml->check_open_dialog_follows_doc = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_open_dialog_follows_doc");
    g_return_val_if_fail (xml->check_open_dialog_follows_doc != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrefsFile), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _prefs_file_xml_free);
    return TRUE;
}

static gboolean
prefs_file_xml_build (PrefsFileXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _prefs_file_xml_glade_xml, -1, "PrefsFile", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_file_xml_finish_build (xml);
}

static gboolean
prefs_file_xml_fill (PrefsFileXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _prefs_file_xml_glade_xml, -1, "PrefsFile", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_file_xml_finish_build (xml);
}

static PrefsFileXml *
prefs_file_xml_new_empty (void)
{
    PrefsFileXml *xml = g_new0 (PrefsFileXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrefsFileXml *
prefs_file_xml_new (void)
{
    PrefsFileXml *xml = prefs_file_xml_new_empty ();
    if (!prefs_file_xml_build (xml))
    {
        _prefs_file_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrefsFileXml *
prefs_file_xml_new_with_root (GtkWidget *root)
{
    PrefsFileXml *xml = prefs_file_xml_new_empty ();
    if (!prefs_file_xml_fill (xml, root))
    {
        _prefs_file_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
