#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _qs_box_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"<widget class=\"GtkWindow\" id=\"window1\">"
"<property name=\"visible\">True</property>"
"<property name=\"title\">window1</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox1\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox1\">"
"<property name=\"visible\">True</property>"
"<child>"
"<placeholder/>"
"</child>"
"<child>"
"<placeholder/>"
"</child>"
"<child>"
"<placeholder/>"
"</child>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkEventBox\" id=\"QsBox\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkFrame\" id=\"frame1\">"
"<property name=\"visible\">True</property>"
"<property name=\"label_xalign\">0</property>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment1\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkEntry\" id=\"entry:MooEntry\">"
"<property name=\"visible\">True</property>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"case_sensitive\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\">_Case sensitive</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"response_id\">0</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"regex\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\">_Regular expression</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"response_id\">0</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEventBox\" id=\"eventbox1\">"
"<property name=\"visible\">True</property>"
"<child>"
"<placeholder/>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"pack_type\">GTK_PACK_END</property>"
"<property name=\"position\">3</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox3\">"
"<property name=\"visible\">True</property>"
"<child>"
"<placeholder/>"
"</child>"
"<child>"
"<placeholder/>"
"</child>"
"<child>"
"<placeholder/>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct QsBoxXml QsBoxXml;

struct QsBoxXml {
    MooGladeXML *xml;

    GtkEventBox *QsBox;
    GtkHBox *hbox;
    MooEntry *entry;
    GtkCheckButton *case_sensitive;
    GtkCheckButton *regex;

};

static void
_qs_box_xml_free (QsBoxXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static QsBoxXml *
qs_box_xml_get (gpointer widget)
{
    return (QsBoxXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_qs_box_xml_finish_build (QsBoxXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->QsBox = (GtkEventBox*) moo_glade_xml_get_widget (xml->xml, "QsBox");
    g_return_val_if_fail (xml->QsBox != NULL, FALSE);
    xml->hbox = (GtkHBox*) moo_glade_xml_get_widget (xml->xml, "hbox");
    g_return_val_if_fail (xml->hbox != NULL, FALSE);
    xml->entry = (MooEntry*) moo_glade_xml_get_widget (xml->xml, "entry:MooEntry");
    g_return_val_if_fail (xml->entry != NULL, FALSE);
    xml->case_sensitive = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "case_sensitive");
    g_return_val_if_fail (xml->case_sensitive != NULL, FALSE);
    xml->regex = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "regex");
    g_return_val_if_fail (xml->regex != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->QsBox), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _qs_box_xml_free);
    return TRUE;
}

static gboolean
qs_box_xml_build (QsBoxXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _qs_box_xml_glade_xml, -1, "QsBox", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _qs_box_xml_finish_build (xml);
}

static gboolean
qs_box_xml_fill (QsBoxXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _qs_box_xml_glade_xml, -1, "QsBox", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _qs_box_xml_finish_build (xml);
}

static QsBoxXml *
qs_box_xml_new_empty (void)
{
    QsBoxXml *xml = g_new0 (QsBoxXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static QsBoxXml *
qs_box_xml_new (void)
{
    QsBoxXml *xml = qs_box_xml_new_empty ();
    if (!qs_box_xml_build (xml))
    {
        _qs_box_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static QsBoxXml *
qs_box_xml_new_with_root (GtkWidget *root)
{
    QsBoxXml *xml = qs_box_xml_new_empty ();
    if (!qs_box_xml_fill (xml, root))
    {
        _qs_box_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
