#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _prefs_page_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"<requires-version lib=\"gtk+\" version=\"2.12\"/>"
"<widget class=\"GtkWindow\" id=\"window1\">"
"<property name=\"visible\">True</property>"
"<property name=\"title\">window1</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"PrefsPage\">"
"<property name=\"visible\">True</property>"
"<property name=\"border_width\">12</property>"
"<property name=\"spacing\">18</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox1\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label1\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">&lt;b&gt;Open With&lt;/b&gt;</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment2\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">12</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox5\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox1\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkScrolledWindow\" id=\"scrolledwindow1\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"hscrollbar_policy\">GTK_POLICY_NEVER</property>"
"<property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"<property name=\"shadow_type\">GTK_SHADOW_IN</property>"
"<child>"
"<widget class=\"GtkTreeView\" id=\"treeview\">"
"<property name=\"visible\">True</property>"
"<property name=\"border_width\">3</property>"
"<property name=\"headers_visible\">False</property>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkTable\" id=\"table\">"
"<property name=\"visible\">True</property>"
"<property name=\"n_rows\">4</property>"
"<property name=\"n_columns\">2</property>"
"<property name=\"column_spacing\">6</property>"
"<property name=\"row_spacing\">6</property>"
"<child>"
"<widget class=\"GtkEventBox\" id=\"eventbox4\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Semicolon-separated list of mime types, e.g. 'text/*;application/x-glade'</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label6\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Mime types:</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">3</property>"
"<property name=\"bottom_attach\">4</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEventBox\" id=\"eventbox3\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Semicolon-separated list of file globs, e.g. '*.txt;foo.*;*bar*'</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label5\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Extensions:</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">2</property>"
"<property name=\"bottom_attach\">3</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEventBox\" id=\"eventbox2\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Shell command to open the file: '%f' is replaced with file path, e.g. 'foobar %f'</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label2\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Command:</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">1</property>"
"<property name=\"bottom_attach\">2</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEventBox\" id=\"eventbox1\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Menu item label</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label4\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Name:</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"label\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Menu item label</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"command\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Shell command to open the file: '%f' is replaced with file path, e.g. 'foobar %f'</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">1</property>"
"<property name=\"bottom_attach\">2</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"extensions\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Semicolon-separated list of file globs, e.g. '*.txt;foo.*;*bar*'</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">2</property>"
"<property name=\"bottom_attach\">3</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"mimetypes\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Semicolon-separated list of mime types, e.g. 'text/*;application/x-glade'</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">3</property>"
"<property name=\"bottom_attach\">4</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox2\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkButton\" id=\"new\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">New</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"response_id\">0</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image3\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-new</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkButton\" id=\"delete\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Delete</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"response_id\">0</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image4\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-delete</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkButton\" id=\"down\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Move down</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"response_id\">0</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image2\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-go-down</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkButton\" id=\"up\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\" translatable=\"yes\">Move up</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"response_id\">0</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image1\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-go-up</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">3</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct PrefsPageXml PrefsPageXml;

struct PrefsPageXml {
    MooGladeXML *xml;

    GtkVBox *PrefsPage;
    GtkTreeView *treeview;
    GtkTable *table;
    GtkEntry *label;
    GtkEntry *command;
    GtkEntry *extensions;
    GtkEntry *mimetypes;
    GtkButton *new_;
    GtkButton *delete_;
    GtkButton *down;
    GtkButton *up;

};

static void
_prefs_page_xml_free (PrefsPageXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_get (gpointer widget)
{
    return (PrefsPageXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_prefs_page_xml_finish_build (PrefsPageXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrefsPage = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "PrefsPage");
    g_return_val_if_fail (xml->PrefsPage != NULL, FALSE);
    xml->treeview = (GtkTreeView*) moo_glade_xml_get_widget (xml->xml, "treeview");
    g_return_val_if_fail (xml->treeview != NULL, FALSE);
    xml->table = (GtkTable*) moo_glade_xml_get_widget (xml->xml, "table");
    g_return_val_if_fail (xml->table != NULL, FALSE);
    xml->label = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "label");
    g_return_val_if_fail (xml->label != NULL, FALSE);
    xml->command = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "command");
    g_return_val_if_fail (xml->command != NULL, FALSE);
    xml->extensions = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "extensions");
    g_return_val_if_fail (xml->extensions != NULL, FALSE);
    xml->mimetypes = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "mimetypes");
    g_return_val_if_fail (xml->mimetypes != NULL, FALSE);
    xml->new_ = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "new");
    g_return_val_if_fail (xml->new_ != NULL, FALSE);
    xml->delete_ = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "delete");
    g_return_val_if_fail (xml->delete_ != NULL, FALSE);
    xml->down = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "down");
    g_return_val_if_fail (xml->down != NULL, FALSE);
    xml->up = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "up");
    g_return_val_if_fail (xml->up != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrefsPage), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _prefs_page_xml_free);
    return TRUE;
}

static gboolean
prefs_page_xml_build (PrefsPageXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _prefs_page_xml_glade_xml, -1, "PrefsPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_page_xml_finish_build (xml);
}

static gboolean
prefs_page_xml_fill (PrefsPageXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _prefs_page_xml_glade_xml, -1, "PrefsPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_page_xml_finish_build (xml);
}

static PrefsPageXml *
prefs_page_xml_new_empty (void)
{
    PrefsPageXml *xml = g_new0 (PrefsPageXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_new (void)
{
    PrefsPageXml *xml = prefs_page_xml_new_empty ();
    if (!prefs_page_xml_build (xml))
    {
        _prefs_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_new_with_root (GtkWidget *root)
{
    PrefsPageXml *xml = prefs_page_xml_new_empty ();
    if (!prefs_page_xml_fill (xml, root))
    {
        _prefs_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
