#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _script_page_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"<!-- interface-requires gtk+ 2.6 -->"
"<!-- interface-naming-policy toplevel-contextual -->"
"<widget class=\"GtkWindow\" id=\"window2\">"
"<property name=\"visible\">True</property>"
"<property name=\"title\">window2</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"ScriptPage\">"
"<property name=\"visible\">True</property>"
"<property name=\"orientation\">vertical</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkScrolledWindow\" id=\"scrolledwindow2\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"hscrollbar_policy\">automatic</property>"
"<property name=\"vscrollbar_policy\">automatic</property>"
"<property name=\"shadow_type\">etched-in</property>"
"<child>"
"<widget class=\"GtkTextView\" id=\"textview:MooTextView\">"
"<property name=\"visible\">True</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct ScriptPageXml ScriptPageXml;

struct ScriptPageXml {
    MooGladeXML *xml;

    GtkVBox *ScriptPage;
    MooTextView *textview;

};

static void
_script_page_xml_free (ScriptPageXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static ScriptPageXml *
script_page_xml_get (gpointer widget)
{
    return (ScriptPageXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_script_page_xml_finish_build (ScriptPageXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->ScriptPage = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "ScriptPage");
    g_return_val_if_fail (xml->ScriptPage != NULL, FALSE);
    xml->textview = (MooTextView*) moo_glade_xml_get_widget (xml->xml, "textview:MooTextView");
    g_return_val_if_fail (xml->textview != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->ScriptPage), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _script_page_xml_free);
    return TRUE;
}

static gboolean
script_page_xml_build (ScriptPageXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _script_page_xml_glade_xml, -1, "ScriptPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _script_page_xml_finish_build (xml);
}

static gboolean
script_page_xml_fill (ScriptPageXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _script_page_xml_glade_xml, -1, "ScriptPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _script_page_xml_finish_build (xml);
}

static ScriptPageXml *
script_page_xml_new_empty (void)
{
    ScriptPageXml *xml = g_new0 (ScriptPageXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static ScriptPageXml *
script_page_xml_new (void)
{
    ScriptPageXml *xml = script_page_xml_new_empty ();
    if (!script_page_xml_build (xml))
    {
        _script_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static ScriptPageXml *
script_page_xml_new_with_root (GtkWidget *root)
{
    ScriptPageXml *xml = script_page_xml_new_empty ();
    if (!script_page_xml_fill (xml, root))
    {
        _script_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
